//+------------------------------------------------------------------+
//|                                           separation_ea_v1.1.mq4 |
//|                                                                  |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "omelette@oceanfree.net"  
 
extern double TakeProfit = 20;
extern double Lots = 1;
extern double StopLoss = 35;
extern double Open_Close_Points=8;
extern string FirstPeriod_Open_Time = "06:00";
extern string FirstPeriod_Close_Time = "06:01";
extern string SecondPeriod_Open_Time = "12:40";
extern string SecondPeriod_Close_Time = "18:00";
extern bool   OneTradePerDay = true;
extern int    MagicNumber = 12345;
int           MATrendPeriodSlow = 26;
int           MATrendPeriodFast = 10;
double        CurrentBar;
datetime      ValidDay;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int cnt,OpenTrades,ticket;
   double MACDprev,MAfast,MAslow;
   bool StartOfNewBar,ValidFirstPeriod,ValidSecondPeriod,ValidEntryTime;
   string BaseTimeString;
   datetime Today;
   if (Bars < MATrendPeriodSlow)
    return;
   if(AccountFreeMargin()<(1*Lots)) {
    Print("We have no money. Free Margin = ", AccountFreeMargin());
    return; }
   StartOfNewBar = NewBarCheck(0);
   if (StartOfNewBar == false)
    return;
   
   OpenTrades = 0;
   for(cnt=0;cnt<OrdersTotal();cnt++) {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
     OpenTrades++; }
   
   MAslow = iMA(NULL,0,MATrendPeriodSlow,0,MODE_EMA,PRICE_CLOSE,0);
   MAfast = iMA(NULL,0,MATrendPeriodFast,0,MODE_EMA,PRICE_CLOSE,0);
   MACDprev = iMACD(NULL,0,10,26,8,PRICE_CLOSE,MODE_MAIN,1);
   BaseTimeString = TimeYear(Time[0]) + "." + TimeMonth(Time[0]) + "." + TimeDay(Time[0])+ " ";
   Today = StrToTime(BaseTimeString);
   
   if (OpenTrades > 0)
    ValidDay = Today;
   if (ValidDay != Today || OneTradePerDay == false)
   {
    ValidFirstPeriod = (Time[0] > StrToTime(BaseTimeString + FirstPeriod_Open_Time)
                    && Time[0] < StrToTime(BaseTimeString + FirstPeriod_Close_Time));
    ValidSecondPeriod = (Time[0] > StrToTime(BaseTimeString + SecondPeriod_Open_Time)
                     && Time[0] < StrToTime(BaseTimeString + SecondPeriod_Close_Time));                
    ValidEntryTime = (ValidFirstPeriod || ValidSecondPeriod); 
      
    if (MAfast > MAslow && MACDprev >= Open_Close_Points * Point && OpenTrades == 0 && ValidEntryTime) {
     ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"macd",MagicNumber,0,Green);
     if(ticket>0)
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
       Print("BUY Order opened : ",OrderOpenPrice());
      else { Print("Error opening BUY order : ",GetLastError()); 
       return(0); } }
     else if (MAfast < MAslow && MACDprev <= -Open_Close_Points * Point && OpenTrades == 0 && ValidEntryTime) {
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"macd",MagicNumber,0,Red);
      if(ticket>0)
       if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
        Print("SELL Order opened : ",OrderOpenPrice());
       else { Print("Error opening SELL order : ",GetLastError()); 
        return(0); } }
   } 
//----
   return(0);
  }
  
  bool NewBarCheck(int StartBar)

{
   if (CurrentBar == Time[StartBar])
    bool temp = false;
   else { CurrentBar = Time[StartBar];
    temp = true; }
    
   return(temp);
}   
//+------------------------------------------------------------------+